<!-- 繼承頁面設定 -->
@extends('layouts/template_vnc')

<!-- 頁面標題變數 -->
@section('title', trans("sidebar.pc.vnc"))

<!-- 頁面主要內容 -->
@section('container')
    <div id="screen">
    </div>
@endsection

<!-- 頁面所需的 JS -->
@section('page_javascript')
    <style>
        .btn-sm {
            margin-left: 5px;
        }

        .widget-box {
            width: 40%;
            margin-left: auto;
            margin-right: 0;
        }
}
    </style>
    <script type="module" crossorigin="anonymous">
		import RFB from './../core/rfb.js';
        $(document).ready(function() {
			
            window.vm = new Vue({
                el: '.main-content',
				data:{
					view_only:'{!!$view_only!!}',
					ip:'{!!$ip!!}',
					password:"{!!$password!!}",
					connect:false,
					sn:''
				},
                methods: {
                   handler(event) {
					 // alert("111");
					}
                },
				mounted: function () {
					
					
					
					
					let rfb;
					let desktopName;
					let self = this;
					
					
					window.addEventListener('beforeunload', function (event) {

						if(self.sn != ''){
							addRecordEnd();
							rfb.disconnect();
						}
					 });
					
					function connectedToServer(e) {
						status("Connected to " + desktopName);
						self.connect = true;
						addRecordStart();
					}

					$("#sendCtrlAltDel").click(function() {
						if(self.connect){
							rfb.sendCtrlAltDel();
						}else{
							alert("當前狀態下不能進行此操作");
						}
					});
					
					$("#cut").click(function() {
						if(self.connect){
							var a = document.createElement("a");
							a.href = rfb.toDataURL();
							a.download = Date.now()+".png"
							a.click();
							a.remove();
						}else{
							alert("當前狀態下不能進行此操作");
						}
					});
					
					
					function addRecordStart(){
						$.ajax({
							url: 'adds',
							type: 'POST',
							data: {id:readQueryVariable('id',''),sn:self.sn},
							success: function(data) {
								if (data.status === 0) {
									self.sn = data.sn;
								}else if(data.status === 1){
									app.alert("參數錯誤:0x000001");
								}else if(data.status === 2){
									app.alert("參數錯誤:0x000002");
								}else{
									app.alert("未知錯誤");
								}
							},
							error: function(x, status, e) {
								app.alert(x.responseText);
							}
						});
					}
					
					function addRecordEnd(){
						$.ajax({
							url: 'adde',
							type: 'POST',
							data: {sn:self.sn},
							success: function(data) {
								if (data.status === 0) {
									
								}else if(data.status === 1){
									app.alert("參數錯誤:0x000001");
								}else if(data.status === 2){
									app.alert("參數錯誤:0x000002");
								}else{
									app.alert("未知錯誤");
								}
							},
							error: function(x, status, e) {
								app.alert(x.responseText);
							}
						});
					}
					
					function disconnectedFromServer(e) {
						if(self.sn != ''){
							addRecordEnd();
						}
						if (e.detail.clean) {
							status("Disconnected");
							self.connect = false;
						} else {
							status("Something went wrong, connection is closed");
							self.connect = false;
						}
					}


					function credentialsAreRequired(e) {
						const password = prompt("Password Required:");
						rfb.sendCredentials({ password: password });
					}

					function updateDesktopName(e) {
						desktopName = e.detail.name;
					}


					function sendCtrlAltDel() {
						rfb.sendCtrlAltDel();
						return false;
					}


					function status(text) {
						document.getElementById('status').textContent = text;
						//alert(text);
					}


					function readQueryVariable(name, defaultValue) {
						const re = new RegExp('.*[?&]' + name + '=([^&#]*)'),
							  match = ''.concat(document.location.href, window.location.hash).match(re);

						if (match) {
							return decodeURIComponent(match[1]);
						}

						return defaultValue;
					}

					const host = readQueryVariable('host', window.location.hostname);
					let port = readQueryVariable('port', window.location.port);
					status("Connecting");
					let url;
					if (window.location.protocol === "https:") {
						url = 'wss';
					} else {
						url = 'ws';
					}
					url += '://' + host;
					if(port) {
						url += ':' + port;
					}else{
						url += ':6080';
					}
					//if(this.ip.startsWith("::")){
						url += '/?token=127.0.0.1:5900';
					//}else{
					//	url += '/?token='+this.ip+':5800';
					//}
					rfb = new RFB(document.getElementById('screen'), url,
								  { credentials: { password: this.password } });

					rfb.addEventListener("connect",  connectedToServer);
					rfb.addEventListener("disconnect", disconnectedFromServer);
					rfb.addEventListener("credentialsrequired", credentialsAreRequired);
					rfb.addEventListener("desktopname", updateDesktopName);

					rfb.viewOnly = readQueryVariable('view_only', this.view_only=='true'?true:false);
					rfb.scaleViewport = readQueryVariable('scale', false);
				}
            });
        });
    </script>
@endsection
